#include "tty.h"
#include "fox-logo.xpm"
#include "arrow.xpm"

int A4C_KEYAREA_LENGTH = 10;

int a4cLoadModules(ttyDime *DIM)
{
  int          n;
  iomeRegister REGF;
  iomeModule * MOD;
  iomeRegistry REG;
  a4cHANDLE    DLL;
  char *       DLLNAME;
  iomeSysInfo  INFO;
  iomeConfig * CONF = &DIM->CONF.MODULES;
  iomeConfig * CFG  = &DIM->CONF.CONF;
  char         buff[1024];

//  strcpy(buff,DIM->ListArea.message);
  
//  sprintf(DIM->ListArea.message,"Loading IMEs/OMEs ...");
//  ttyDrawPanel(DIM);

  if (CONF->size==0) return 0;
  INFO.system   = "tty";
  INFO.platform = "a4c.tty";
  INFO.version  = "0.1.0";
  INFO.charset  = DIM->current_charset;
  DIM->dl_handles = 0;
  DIM->SO_HANDLES = (a4cHANDLE*)malloc(sizeof(a4cHANDLE)*CONF->size);
  for (n=0;n<CONF->size;n++) 
    if (strcmp(CONF->items[n].key,"load")==0) {
    
    DLLNAME = CONF->items[n].value;
    DIM->SO_HANDLES[DIM->dl_handles] = dlopen(DLLNAME,RTLD_NOW);
    DLL = DIM->SO_HANDLES[DIM->dl_handles];
    DIM->dl_handles++;
    REGF = dlsym(DLL,IME_REGISTER);

    if (REGF&&REGF(&INFO,&REG)) {

      /* See What Type of Module it is */
      if (strcmp(REG.class,"ime")==0) {
        /* Good, it's an input method, load it */
        /* Append a new method */
        DIM->METHOD=(iomeModule**)realloc(DIM->METHOD,sizeof(iomeModule*)*(DIM->method_size+1));
        MOD=(iomeModule*)malloc(sizeof(iomeModule));
        DIM->METHOD[DIM->method_size]=MOD;
        DIM->method_size++;
        /* Load Functions */
        memset(MOD,0,sizeof(iomeModule));

        #define LOADIT(fn,name)\
           MOD->fn = dlsym(DLL,name);\
           if (MOD->fn==NULL)\
             die("Can not load function %s in %s",name,DLLNAME);
        
        LOADIT(INIT,IME_INIT);
        LOADIT(PREPARE,IME_PREPARE);
        LOADIT(FEEDKEY,IME_FEEDKEY);
        LOADIT(LISTAREA,IME_LISTAREA);
        LOADIT(KEYAREA,IME_KEYAREA);
        LOADIT(FOCUS,IME_FOCUS);
        LOADIT(QUIT,IME_QUIT);

        #undef  LOADIT
        /* Initialize it */
        MOD->RECORD.MaxListArea = (A4C_KEYAREA_LENGTH+
                                   A4C_METHOD_LENGTH+
                                   A4C_CHARSET_LENGTH+
                                   A4C_FONTSIZE_LENGTH)*2;
        MOD->RECORD.MaxKeyArea  = A4C_KEYAREA_LENGTH * 2;
        
        MOD->INIT(CFG,&MOD->RECORD);
        
      } else
      if (strcmp(REG.class,"filter")==0) {
        /* Excellent, we have a filter */
        DIM->FILTER = (iomeModule**)realloc(DIM->FILTER,sizeof(iomeModule*)*(DIM->filter_size+1));
        MOD = (iomeModule*)malloc(sizeof(iomeModule));
        DIM->FILTER[DIM->filter_size] = MOD;
        DIM->filter_size++;
        /* Load Functions */
        #define LOADIT(fn,name)\
           MOD->fn = dlsym(DLL,name);\
           if (MOD->fn==NULL)\
             die("Can not load function %s in %s",name,DLLNAME);

        LOADIT(INIT,IME_INIT);
        LOADIT(SIMPLE,IME_SIMPLE);
        LOADIT(QUIT,IME_QUIT);

        #undef  LOADIT
        /* Initialize it */
        MOD->RECORD.MaxListArea = (A4C_KEYAREA_LENGTH+
                                   A4C_METHOD_LENGTH+
                                   A4C_CHARSET_LENGTH+
                                   A4C_FONTSIZE_LENGTH)*2;
        MOD->RECORD.MaxKeyArea  = A4C_KEYAREA_LENGTH * 2;

        MOD->INIT(CFG,&MOD->RECORD);

      } else
        printf("%s: module type?",CONF->items[n].value);
    }
  }
  
//  strcpy(DIM->ListArea.message,buff);
//  ttyDrawPanel(DIM);
}

int a4cFreeModules(ttyDime *DIM)
{
  int n;

  /* porque metodo cero esta ingles */
  for (n=1;n<DIM->method_size;n++) {
    DIM->METHOD[n]->QUIT(&DIM->METHOD[n]->RECORD);
  }

  /* porque filtro cero esta nada */  
  for (n=1;n<DIM->filter_size;n++) {
    DIM->FILTER[n]->QUIT(&DIM->FILTER[n]->RECORD);
  }

  while (DIM->dl_handles>0) {
    DIM->dl_handles--;
    dlclose(DIM->SO_HANDLES[DIM->dl_handles]);
  }
  return 0;
}

int UnifyCharset(ttyDime *DIM,char *str)
{
  if (strcmp(DIM->base_charset,DIM->current_charset)!=0) {
    if (strcmp(DIM->base_charset,"gb2312")==0) {
      ConvertChinese(BIG5_GB2312,str);
    } else
    if (strcmp(DIM->base_charset,"big5")==0) {
      ConvertChinese(GB2312_BIG5,str);
    }
  }
  return 0;
}



void ttyDrawMenuButton(ttyDime *DIM,int up_down)
{
  swDrawBox(&DIM->Menu,&DIM->bgcolor,up_down);
  bitblt(DIM->Menu.x1+2,DIM->Menu.y1+2,DIM->logo_w,DIM->logo_h,DIM->logo);
}

int SetupTTY(
      ttyDime * DIM,
      char ** VideoModeList,
      char * dev_console,
      char * dev_mouse,
      char ** argv
    )
{
  int login;
  DIM->VideoMode = swFindVideoMode(VideoModeList);
  swSetupVideo(DIM->VideoMode);
  vga_setdisplaystart(0);
  setcolor(0,0,0);
  fillbox(0,0,swWidth,swHeight);

  swSetupKey(dev_console);
  mice_init(dev_mouse,arrow_xpm);
  if (!swLoadFont()) return 0;
  
  ttyCalcResolution(DIM);
  swDrawBox(&DIM->Panel,&DIM->bgcolor,1);
  swDrawBox(&DIM->Scroll,&DIM->bgcolor,1);
  ttyDrawMenuButton(DIM,1);
  swDrawBox(&DIM->Method.Border,&DIM->bgcolor,0);
  swDrawBox(&DIM->KeyArea.Border,&DIM->bgcolor,0);
  swDrawBox(&DIM->FontSize.Border,&DIM->bgcolor,0);
  swDrawBox(&DIM->Charset.Border,&DIM->bgcolor,0);

  DIM->pty = open_pty(DIM->ptyname);
  if (DIM->pty==-1) CloseTTY(DIM);
  
  if (argv[0]==NULL) login=0; else login = (strcmp(argv[0],"login")==0);
  if (open_tty(DIM->ptyname,DIM->row,DIM->col,login)==0) CloseTTY(DIM);
  DIM->TERM = swCreateTerminal(0,0,DIM->row,DIM->col);
  DIM->TERM->pty = DIM->pty;
  
  FD_ZERO(&DIM->rptyset);
  FD_SET(DIM->pty,&DIM->rptyset);
  
  return 1;
}

int ttyNextEvent(ttyDime * DIM)
{
  struct timeval tv;

  #define MOUSE_LRB (MOUSE_LEFTBUTTON|MOUSE_RIGHTBUTTON)
  
  if (mouse_update()) {
    if (mice_update) mice_move(mice_x,mice_y);
    if (swIsInside(mice_x,mice_y,&DIM->Menu)) {
      if (mice_button&MOUSE_LEFTBUTTON) return TTY_EVENT_MICE_MENU;
    } else
    if (swIsInside(mice_x,mice_y,&DIM->Scroll)) {
      if (mice_button&MOUSE_LEFTBUTTON) return TTY_EVENT_MICE_SCROLL;
    } else
    if (swIsInside(mice_x,mice_y,&DIM->Term)) {
      if (mice_button&MOUSE_LRB)
        return TTY_EVENT_MICE_TERM;
    } else
    if (swIsInside(mice_x,mice_y,&DIM->Method.Text)) {
      if (mice_button&MOUSE_LRB) return TTY_EVENT_MICE_METHOD;    
    } else
    if (swIsInside(mice_x,mice_y,&DIM->Charset.Text)) {
      if (mice_button&MOUSE_LRB) return TTY_EVENT_MICE_CHARSET;
    } else
    if (swIsInside(mice_x,mice_y,&DIM->FontSize.Text)) {
      if (mice_button&MOUSE_LRB) return TTY_EVENT_MICE_FONTSIZE;
    } else
    if (swIsInside(mice_x,mice_y,&DIM->ListArea.Text)) {
      if (mice_button&MOUSE_LEFTBUTTON) return TTY_EVENT_MICE_LISTAREA;
    } else
    if (swIsInside(mice_x,mice_y,&DIM->KeyArea.Text)) {
      if (mice_button&MOUSE_LEFTBUTTON) return TTY_EVENT_MICE_KEYAREA;
    }
  }
  if (swIsKeyAvailable()) return TTY_EVENT_KEYPRESS;
  DIM->ptyset = DIM->rptyset;
  tv.tv_sec = tv.tv_usec = 0;
  if (select(FD_SETSIZE,&DIM->ptyset,NULL,NULL,&tv)==-1) return -1;
  if (FD_ISSET(DIM->pty,&DIM->ptyset)) return TTY_EVENT_VTMSG;

  return -1;
}

int CloseTTY(ttyDime *DIM)
{
  a4cFreeModules(DIM);
  swClose();
  swCloseKey();
  exit(-1);
}

int ttyCalcResolution(ttyDime * DIM)
{
  /* Term Dimension */
  DIM->row = (swWidth/FONT.width)*2;
  DIM->col = swHeight/(FONT.height+1);
  DIM->col -= 3;
  /* Term */
  DIM->Term.x1 = 0;
  DIM->Term.y1 = 0;
  DIM->Term.x2 = (DIM->row * FONT.width)/2 - 1;
  DIM->Term.y2 = DIM->col * (FONT.height+1) - 1;
  /* Panel */
  DIM->Panel.x1 = 0;
  DIM->Panel.x2 = DIM->Term.x2;
  DIM->Panel.y1 = DIM->Term.y2 + 1;
  DIM->Panel.y2 = swHeight - 1;
  /* Scroll Bar */
  DIM->Scroll.x1 = DIM->Term.x2 + 1;
  DIM->Scroll.x2 = swWidth - 1;
  DIM->Scroll.y1 = 0;
  DIM->Scroll.y2 = swHeight - 1;
  if (DIM->Scroll.x1>DIM->Scroll.x2) {
    DIM->Panel.x2  -= FONT.width;
    DIM->Scroll.x1 -= FONT.width;
    DIM->Scroll.y1  = DIM->Panel.y1;
  }
  /* Menu */
  DIM->logo = create_image_xpm(&DIM->logo_w,&DIM->logo_h,fox_logo_xpm);
  DIM->Menu.y2 = DIM->Panel.y2 - DIM->Panel.y1 - 3;
  DIM->Menu.y2 -= (DIM->logo_h+4);
  DIM->Menu.y2 /= 2;
  DIM->Menu.x1 = DIM->Panel.x1 + 2 + DIM->Menu.y2;
  DIM->Menu.y1 = DIM->Panel.y1 + 2 + DIM->Menu.y2;
  DIM->Menu.x2 = DIM->Menu.x1 + DIM->logo_w + 3;
  DIM->Menu.y2 = DIM->Menu.y1 + DIM->logo_h + 3;
  /* ListArea */
  DIM->ListArea.Border = DIM->Panel;
  DIM->ListArea.Border.y2 -= DIM->ListArea.Border.y1;
  DIM->ListArea.Border.y2++;
  DIM->ListArea.Border.x1 += DIM->ListArea.Border.y2;
  DIM->ListArea.Border.y1 += 3;
  DIM->ListArea.Border.y2 = DIM->ListArea.Border.y1 + 6 + FONT.height;
  DIM->ListArea.Border.x2 -= 3;
  DIM->ListArea.Text = DIM->ListArea.Border;
  DIM->ListArea.Text.x1 += 3;
  DIM->ListArea.Text.y1 += 3;
  DIM->ListArea.Text.x2 -= 3;
  DIM->ListArea.Text.y2 -= 3;
  DIM->ListArea.style = A4C_STYLE_NOBORDER;
  /* Input Method */
  DIM->Method.Border.x1 = DIM->ListArea.Border.x1;
  DIM->Method.Border.x2 = DIM->Method.Border.x1;
  DIM->Method.Border.x2+= FONT.width * A4C_METHOD_LENGTH;
  DIM->Method.Border.x2+= 6;
  DIM->Method.Border.y2 = DIM->Panel.y2 - 4;
  DIM->Method.Border.y1 = DIM->Method.Border.y2 - FONT.height - 6;
  DIM->Method.Text = DIM->Method.Border;
  DIM->Method.Text.x1 += 3;
  DIM->Method.Text.y1 += 3;
  DIM->Method.Text.x2 -= 3;
  DIM->Method.Text.y2 -= 3;
  DIM->Method.style = A4C_STYLE_CENTER;
  /* Font Size */
  DIM->FontSize.Border = DIM->Method.Border;
  DIM->FontSize.Border.x2 = DIM->Panel.x2 - 2;
  DIM->FontSize.Border.x1 = DIM->FontSize.Border.x2 - 4;
  DIM->FontSize.Border.x1 -= FONT.width * A4C_FONTSIZE_LENGTH;
  DIM->FontSize.Text = DIM->FontSize.Border;
  DIM->FontSize.Text.x1 += 3;
  DIM->FontSize.Text.y1 += 3;
  DIM->FontSize.Text.x2 -= 3;
  DIM->FontSize.Text.y2 -= 3;
  DIM->FontSize.style = A4C_STYLE_CENTER;
  /* Output Method */
  DIM->Charset.Border = DIM->Method.Border;
  DIM->Charset.Border.x2 = DIM->FontSize.Border.x1 - 2;
  DIM->Charset.Border.x1 = DIM->Charset.Border.x2 - 4;
  DIM->Charset.Border.x1 -= FONT.width * A4C_CHARSET_LENGTH;
  DIM->Charset.Text = DIM->Charset.Border;
  DIM->Charset.Text.x1 += 3;
  DIM->Charset.Text.y1 += 3;
  DIM->Charset.Text.x2 -= 3;
  DIM->Charset.Text.y2 -= 3;
  DIM->Charset.style = A4C_STYLE_CENTER;
  /* KeyArea */
  DIM->KeyArea.Border = DIM->Method.Border;
  DIM->KeyArea.Border.x1 = DIM->Method.Border.x2 + 2;
  DIM->KeyArea.Border.x2 = DIM->Charset.Border.x1 - 2;
  DIM->KeyArea.Text = DIM->KeyArea.Border;
  DIM->KeyArea.Text.x1 += 3;
  DIM->KeyArea.Text.y1 += 3;
  DIM->KeyArea.Text.x2 -= 3;
  DIM->KeyArea.Text.y2 -= 3;
  DIM->KeyArea.style = A4C_STYLE_NORMAL;
  A4C_KEYAREA_LENGTH = 
    (DIM->KeyArea.Text.x2-DIM->KeyArea.Text.x1-2)/FONT.width;
  
  return 1;
}

int isInKeyBox(int x,int y,a4cKeyBox *KEYBOX)
{
  return swIsInside(x,y,&KEYBOX->Text);
}

void ttyDrawPanel(ttyDime *DIM)
{
  mice_recover();
  swDrawButton(
    &DIM->Method.Border,
    &DIM->bgcolor,
    &DIM->fgcolor,
    0,
    DIM->Method.message
  );
  swDrawButton(
    &DIM->Charset.Border,
    &DIM->bgcolor,
    &DIM->fgcolor,
    0,
    DIM->Charset.message
  );
  swDrawButton(
    &DIM->FontSize.Border,
    &DIM->bgcolor,
    &DIM->fgcolor,
    0,
    DIM->FontSize.message
  );
  setcolor(DIM->bgcolor.r,DIM->bgcolor.g,DIM->bgcolor.b);
  fillbox(
    DIM->KeyArea.Text.x1,
    DIM->KeyArea.Text.y1,
    DIM->KeyArea.Text.x2 - DIM->KeyArea.Text.x1 + 1,
    DIM->KeyArea.Text.y2 - DIM->KeyArea.Text.y1 + 1
  );
  fillbox(
    DIM->ListArea.Text.x1,
    DIM->ListArea.Text.y1,
    DIM->ListArea.Text.x2 - DIM->ListArea.Text.x1 + 1,
    DIM->ListArea.Text.y2 - DIM->ListArea.Text.y1 + 1
  );
  setforeground(DIM->fgcolor.r,DIM->fgcolor.g,DIM->fgcolor.b);
  setbackground(DIM->bgcolor.r,DIM->bgcolor.g,DIM->bgcolor.b);
  swputs(
    DIM->KeyArea.Text.x1+1,
    DIM->KeyArea.Text.y1+1,
    DIM->KeyArea.message
  );
  swputs(
    DIM->ListArea.Text.x1+1,
    DIM->ListArea.Text.y1+1,
    DIM->ListArea.message
  );
  mice_move(mouse_x,mouse_y);
}

